#ifndef __ANNIFILE_H
#define __ANNIFILE_H

#include "date.h"

typedef struct _AnniFile
{
  char name[256];
  char type;
  
  int isHebrewDate;
  CalDate dateAnni;
  int afterSunset;

  struct _AnniFile* next;
} AnniFile;

void AnniFileInit(AnniFile** af);
void AnniFileDone(AnniFile** af);
void AnniFileInsertSorted(AnniFile** af, char *name, char type,
                          int isHebrewDate, CalDate* dateAnni, int afterSunset);
int AnniFileCount(AnniFile** af);
void AnniFileGet(AnniFile** af, int index, char *name, char *type,
                 int *isHebrewDate, CalDate* dateAnni, int* afterSunset);
void AnniFileModify(AnniFile** af, int index, char *name, char type,
                    int isHebrewDate, CalDate* dateAnni, int afterSunset);
void AnniFileRemove(AnniFile** af, int index);

void AnniFileGetFilename(char *filename);
void AnniFileStore(AnniFile** af);
void AnniFileLoad(AnniFile** af);

int AnnifileGetForDay(long currentDate, char *caption, char *text);

#endif

