#include <gtk/gtk.h>
#include "config.h"
#include "halacha.h"
#include "paint.h"
#include "version.h"
#include "settings.h"
#include "dialogs.h"

int idClickedButton;

void DialogButton(GtkWidget* widget, gpointer data)
{
  idClickedButton = (int) data;
}

void DialogDestroy(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

int DialogsDoMessageEx(char *msg, int ok, int yesno)
{
  GtkDialog *dialog;
  char *msgLauf, text[256], *textLauf;
  GtkLabel *label;
  GtkButton *button;

  dialog = GTK_DIALOG(gtk_dialog_new());
  gtk_window_set_title(GTK_WINDOW(dialog), "Message");

  msgLauf = msg;
  while (*msgLauf)
  {
    textLauf = text;
    while ((*msgLauf != 0) && (*msgLauf != '\n'))
    {
      *textLauf++ = *msgLauf;
      msgLauf++;
    }
    *textLauf = 0;
    if (*msgLauf == '\n') msgLauf++;

    label = GTK_LABEL(gtk_label_new(text));
    gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(label));
    gtk_widget_show(GTK_WIDGET(label));
  }

  if (ok)
  {
    button = GTK_BUTTON(gtk_button_new_with_label("OK"));
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
                       GTK_SIGNAL_FUNC(DialogDestroy), (gpointer) dialog);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                       GTK_WIDGET(button), TRUE, TRUE, 0);
    gtk_widget_show(GTK_WIDGET(button));
  }
  if (yesno)
  {
    button = GTK_BUTTON(gtk_button_new_with_label("Yes"));
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
                       GTK_SIGNAL_FUNC(DialogButton), (gpointer) IDYES);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                       GTK_WIDGET(button), TRUE, TRUE, 0);
    gtk_widget_show(GTK_WIDGET(button));

    button = GTK_BUTTON(gtk_button_new_with_label("No"));
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
                       GTK_SIGNAL_FUNC(DialogButton), (gpointer) IDNO);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                       GTK_WIDGET(button), TRUE, TRUE, 0);
    gtk_widget_show(GTK_WIDGET(button)); 
      
    gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
                       GTK_SIGNAL_FUNC(DialogButton), (gpointer) IDNO);
  }

  gtk_widget_show(GTK_WIDGET(dialog));
  
  if (yesno)
  {
    idClickedButton = (-1);
    while (idClickedButton == (-1))
    {
/*    if (gtk_events_pending())*/
        gtk_main_iteration();
    }

    if (GTK_IS_DIALOG(dialog)) gtk_widget_destroy(GTK_WIDGET(dialog));

    return (idClickedButton);
  }
  else
    return (-1);
}

void DialogsDoMessage(char *msg)
{
  (void) DialogsDoMessageEx(msg, 1, 0);
}

int DialogsDoYesNo(char *msg)
{
  return DialogsDoMessageEx(msg, 0, 1);
}

void DialogsDoAbout(void)
{
  char msg[256];

  sprintf(msg, "%s\n%s\n%s\n%s\n%s", 
          APPTITLE, VERSION, COPYRIGHT1, COPYRIGHT2, COPYRIGHT3);
  DialogsDoMessage(msg);
}

#define TEXT_SCROLLED_WIDTH      210
#define TEXT_SCROLLED_HEIGHT     100

void DialogsDoLongMessage(GtkWindow *parent, char *msg1, char *msg2)
{
  GtkDialog *dialog;
  int i;
  GtkList *list;
  GList *glist;
  GtkListItem *listItem;
  char *msgLauf, line[256], *lineLauf;
  GtkScrolledWindow *scrolledWindow;
  GtkButton *button;

  dialog = GTK_DIALOG(gtk_dialog_new());
  gtk_window_set_title(GTK_WINDOW(dialog), "Message");
/*if (parent)
    gtk_window_set_transient_for(GTK_WINDOW(dialog), parent);*/
  gtk_widget_set_usize(GTK_WIDGET(dialog), INITIAL_WIDTH, INITIAL_HEIGHT);
  
  for (i = 0; i < 2; i++)
  {
    list = GTK_LIST(gtk_list_new());
    glist = NULL;

    if (i == 0)
      msgLauf = msg1;
    else
      msgLauf = msg2;
    while (*msgLauf)
    {
      lineLauf = line;
      while ((*msgLauf != 0) && (*msgLauf != '\n'))
      {
        *lineLauf++ = *msgLauf;
        msgLauf++;
      }
      *lineLauf = 0;
      if (*msgLauf == '\n') msgLauf++;

      listItem = GTK_LIST_ITEM(gtk_list_item_new_with_label(line));
      gtk_widget_show(GTK_WIDGET(listItem));
      glist = g_list_append(glist, listItem);
    }

    gtk_list_append_items(GTK_LIST(list), glist);
 
    scrolledWindow = GTK_SCROLLED_WINDOW(gtk_scrolled_window_new(NULL, NULL));
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolledWindow),
                                          GTK_WIDGET(list));

    gtk_widget_set_usize(GTK_WIDGET(scrolledWindow),
                         TEXT_SCROLLED_WIDTH, TEXT_SCROLLED_HEIGHT);

    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),
                      GTK_WIDGET(scrolledWindow));
    gtk_widget_show(GTK_WIDGET(list));
    gtk_widget_show(GTK_WIDGET(scrolledWindow));
  }

  button = GTK_BUTTON(gtk_button_new_with_label("Close"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(DialogDestroy), (gpointer) dialog);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  gtk_widget_show(GTK_WIDGET(dialog));
}

int DialogsDoYear(int year)
{
  GtkDialog* dialog;
  GtkLabel* label;
  GtkEntry* editField;
  GtkButton* button;
  char *text, *endptr, text2[256], msg[256];
  int iReturnYear;

  dialog = GTK_DIALOG(gtk_dialog_new());
  gtk_window_set_title(GTK_WINDOW(dialog), "Select Year");

  label = GTK_LABEL(gtk_label_new("Year:"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(label));
  gtk_widget_show(GTK_WIDGET(label));

  editField = GTK_ENTRY(gtk_entry_new());
  sprintf(text2, "%d", year);
  gtk_entry_set_text(editField, text2);
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(editField));
  gtk_widget_show(GTK_WIDGET(editField));

  button = GTK_BUTTON(gtk_button_new_with_label("OK"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(DialogButton), (gpointer) 1);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  button = GTK_BUTTON(gtk_button_new_with_label("Cancel"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(DialogButton), (gpointer) 2);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
                     GTK_SIGNAL_FUNC(DialogButton), (gpointer) 2);

  gtk_widget_show(GTK_WIDGET(dialog));
  iReturnYear = (-1);
  while (iReturnYear == (-1))
  {
    idClickedButton = (-1);
    while (idClickedButton == (-1))
    {
/*    if (gtk_events_pending())*/
        gtk_main_iteration();
    }
    if (idClickedButton == 1)
    {
      text = gtk_entry_get_text(GTK_ENTRY(editField));
      if (text)
      {
        iReturnYear = strtol(text, &endptr, 10);
        if (endptr)
        {
          if (*endptr != 0)
          {
            DialogsDoMessage("Year must be a number");
            iReturnYear = (-1);
          }
        }
        if (((iReturnYear < YEAR_BEGIN) || (iReturnYear > YEAR_END)) &&
            (iReturnYear != (-1)))
        {
          sprintf(msg, "Year must be in range %d-%d",
                  YEAR_BEGIN, YEAR_END);
          DialogsDoMessage(msg);
          iReturnYear = (-1);
        } 
      }
    }
    else
      iReturnYear = 0;
  }

  if (GTK_IS_DIALOG(dialog)) gtk_widget_destroy(GTK_WIDGET(dialog));
  return (iReturnYear);
}

int DialogsConfigureIsraelDiasporaStyle(void)
{
  GtkDialog *dialog;
  GtkLabel *label;
  GtkRadioButton *diaspora, *israel;
  GtkRadioButton *sephardicStyle, *ashkenaziStyle;
  GtkButton *button;
  int style;

  dialog = GTK_DIALOG(gtk_dialog_new());
  gtk_window_set_title(GTK_WINDOW(dialog), "Set Israel/Diaspora & Style");

  label = GTK_LABEL(gtk_label_new("Israel/Diaspora"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(label));
  gtk_widget_show(GTK_WIDGET(label));

  diaspora = GTK_RADIO_BUTTON(gtk_radio_button_new_with_label
              (NULL, "Diaspora"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(diaspora));
  gtk_widget_show(GTK_WIDGET(diaspora));

  israel = GTK_RADIO_BUTTON(gtk_radio_button_new_with_label_from_widget
              (diaspora, "Israel"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(israel));
  gtk_widget_show(GTK_WIDGET(israel));

  if (diasporaGetFlag())
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(diaspora), TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(israel), TRUE);

  label = GTK_LABEL(gtk_label_new("Style"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(label));
  gtk_widget_show(GTK_WIDGET(label));

  sephardicStyle = GTK_RADIO_BUTTON(gtk_radio_button_new_with_label
               (NULL, "Sephardic"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(sephardicStyle));
  gtk_widget_show(GTK_WIDGET(sephardicStyle));

  ashkenaziStyle = GTK_RADIO_BUTTON(gtk_radio_button_new_with_label_from_widget
                (sephardicStyle, "Ashkenazi"));
  gtk_container_add(GTK_CONTAINER(dialog->vbox), GTK_WIDGET(ashkenaziStyle));
  gtk_widget_show(GTK_WIDGET(ashkenaziStyle));

  style = getStyle();
  switch (style)
  {
    case sephardic:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(sephardicStyle), TRUE);
      break;
    case ashkenazi:
    default:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ashkenaziStyle), TRUE);
      break;
  }

  button = GTK_BUTTON(gtk_button_new_with_label("OK"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(DialogButton), (gpointer) 1);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  button = GTK_BUTTON(gtk_button_new_with_label("Cancel"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(DialogButton), (gpointer) 2);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
                     GTK_SIGNAL_FUNC(DialogButton), (gpointer) 2);

  gtk_widget_show(GTK_WIDGET(dialog));
  idClickedButton = (-1);
  while (idClickedButton == (-1))
  {
/*  if (gtk_events_pending())*/
      gtk_main_iteration();
  }
  if (idClickedButton == 1)
  {
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(diaspora)))
      diasporaSetFlag(1);
    else
      diasporaSetFlag(0);

    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(sephardicStyle)))
      style = sephardic;
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ashkenaziStyle)))
      style = ashkenazi;
    setStyle(style);
  }

  if (GTK_IS_DIALOG(dialog)) gtk_widget_destroy(GTK_WIDGET(dialog));

  if (idClickedButton == 1)
    return 1;
  else
    return 0;
}

