#define HALACHA_INTERNAL
#include <stdio.h>
#include <string.h>
#include "holidays.h"
#include "names.h"
#include "torah.h"
#include "molad.h"
#include "halacha2.h"
#include "halacha.h"

extern int halachaDiaspora;

#define festival(day) (isDay(day,"Pesakh_I") || isDay(day, "Pesakh_VII") || \
	isDay(day, "Shavuot_I") || isDay(day, "Sukkot_I") || \
	isDay(day, "Shemini_atseres_I")) || (diaspora && \
		(isDay(day, "Pesakh_II") || isDay(day, "Pesakh_VIII") || \
		 isDay(day, "Shavuot_II") || isDay(day, "Sukkot_II") || \
		 isDay(day, "Shemini_atseres_II")))
#define yom_kippur(day) isDay(day, "yom_kippur")
#define wantMusaf(day) 	(sabbath(day) || festival(day) || high_holiday(day) || \
		rosh_khodesh(day) || khol_haMoed(day))
#define eighteen_blessings(day) \
	(!(sabbath(day) || festival(day) || high_holiday(day)))
#define wantBirkatHakhodesh(day) \
	(sabbath(day) && day_in_month(day) <= 29 && day_in_month(day) >= 23)
#define end_teyn_brokhe(day) \
	(israel ? hebrDate(Heshvan, 6, day) : (civil_year(day) % 4 == 3 ? \
	gregDate(December, 5, day) : gregDate(December, 4, day)))
#define no_takhanun(day) \
	( (!sabbath(day) && wantMusaf(day)) || khol_haMoed(day) || \
	rosh_haShana(day+1) || ((hebrDate(Nisan, 1, day) <= day) && \
	(day <= hebrDate(Nisan, 30, day))) || day_in_omer(day)==33 || \
	((hebrDate(Sivan, 1, day) <= day) && (day <= h_holiday(day, "SHAVUOT_I"))) \
	||	tisha_beAv(day) || Av_15(day) || \
	((day >= h_holiday(day, "YOM_KIPPUR")) && \
	(day < h_holiday(day, "SHMINI_ATSERES_I"))) ||	khanukah(day) || \
	tu_beshvat(day) || purim(day) || shushan_purim(day) || adar_14(day) || \
	adar_15(day) )
#define isFastday(day)	\
	(isDay(day, "tzom_gedalia") || isDay(day, "yom_kippur") || \
	 isDay(day, "tzom_tevet") || isDay(day, "taanit_esther") || \
	 isDay(day, "tzom_tammuz") || isDay(day, "tisha_beav"))
#define named_shabbat(day) \
	(shabbat_zakhor(day) || shabbat_parah(day) || shabbat_haKhodesh(day) || \
	 shabbat_shekalim(day))
#define penitential(day) \
	( ((day >= hebrDate(Elul, 1, day)) && (day <= hebrDate(Elul, 29, day))) || \
	((day >= hebrDate(Tishri, 1, day)) && \
	 (day <= h_holiday(day, "SUKKOT_VII"))) )
#define append_str(target, initial, separator, source)	\
	if (*source) { \
		if (*target) strcat(target, separator); \
		else strcat(target, initial); \
		strcat(target, source);	\
	}
#define khannuka(day) ( \
	((day) >= h_holiday(tomorrow, "KHANNUKA_I") && \
	(day) <= h_holiday(tomorrow, "KHANNUKA_VII")))


void HalachaOutput(char *msg);

void HalachaOutputInt(char *msg, int i)
{
  char msg2[256];

  sprintf(msg2, msg, i);
  HalachaOutput(msg2);
}

HALACHA_EXTERN void HalachaDo(long today, int diaspora, int style)
{
  long tomorrow;
  int israel, sefers, aliyot;
  char str[256], outbuffer[256];
  int aidTorah[3];

  tomorrow = today + 1;
  halachaDiaspora = diaspora;

  if (diaspora) israel = 0; else israel = 1;

GetSpecialDay(today, str);
if (strcmp(str, "") != 0) {
	sprintf(outbuffer, "  %s", str);
	HalachaOutput(outbuffer);
}

// standard additions: Mashiv haRuakh/Morid haTal; Teyn Berakha/Tal
if (today > h_holiday(today, "SHMINI_ATSERES_I") &&
		today < h_holiday(today, "PESAKH_I")) {
	HalachaOutput("  Mashiv haRuakh");
} else if (style(sephardic)) {
	HalachaOutput("  Morid haTal");
} else
	HalachaOutput("  no Mashiv haRuakh");
if (eighteen_blessings(today)) {
	if (today > h_holiday_prev(today, "PESAKH_I") &&
			today <= end_teyn_brokhe(today))
		HalachaOutput("  Teyn Berakha");
	else
		HalachaOutput("  Teyn Tal uMatar");
}
if (today >= h_holiday(today, "SUKKOT_I") &&
		today <= h_holiday(today, "SUKKOT_VII"))
	HalachaOutput("  All meals in the Sukkah (with berakha)");
if (isDay(today, "Shemini_atseres_I")) 
	HalachaOutput("  All meals in the Sukkah (without berakha)");
if (khol_haMoed(today) && !sabbath(today)) {
	if (!diaspora || sephardic) 
		HalachaOutput("  No tefilin today (customs vary)");
	else 
		HalachaOutput("  Tefilin today (customs vary)");
}

HalachaOutput("Shakharit");
	if (tisha_beAv(today)) {
		HalachaOutput("  No tallit or tefillin until Minkha");
	} else if (khannuka(today)) {
		HalachaOutput("  Light candles before Shakharit in synagogue ");
		HalachaOutput("    without blessings");
	}
	if (eighteen_blessings(today)) {
		if (today == h_holiday(today, "SUKKOT_VII")) {
			HalachaOutput("  LaMinatseyekh Mizmor leDavid");
			HalachaOutput("  Mizmor leToda");
		} else if (! (isDay(tomorrow, "yom_kippur") || 
				isDay(tomorrow, "Pesakh_I")) &&
                 ! (khol_haMoed_Pesakh(today))) {
		 	// HalachaOutput("  Mizmor leToda");
		} else {
			HalachaOutput("  no Mizmor leToda");
		}
	} else {
		HalachaOutput("  LaMinatseyekh Mizmor leDavid");
	}
	if (rosh_khodesh(today) || khannuka(today)) {
		HalachaOutput("  Barekhi nafshi (Psalm 104)");
	}
	if (isDay(today, "tzom_gedalia")) {
		HalachaOutput("  Shir haMaalot miMaamakim");
		HalachaOutput("    (Psalm 130) after Yishtabakh");
	}
	if (today >= h_holiday(today, "ROSH_HASHANA_I") && today <=
			h_holiday(today, "yom_kippur")) {
		HalachaOutput("  Zokhreynu leKhayim");
        }
	if (today == h_holiday(today, "SHMINI_ATSERES_I")) {
		if (style(sephardic))
			HalachaOutput("  Morid haTal (last time)");
		else
			HalachaOutput("  no Morid haTal (last time)");
	} else if (today == h_holiday(today, "PESAKH_I")) {
		HalachaOutput("  Mashiv haRuakh (last time)");
	}
	if (festival(today) || high_holiday(today) || rosh_khodesh(today) ||
			khol_haMoed(today))
		HalachaOutput("  Yaale veYavo");
	if (isDay(today, "Purim") || khannuka(today))
		HalachaOutput("  Al haNisim");
	if (isFastday(today)) {
		if (sabbath(today))
			HalachaOutput("  no Avinu Malkeynu");
		else
			if (!yom_kippur(today)) {
				HalachaOutput("  Aneynu (in repetition)");
			}
			if (tisha_beAv(today)) {
				HalachaOutput("  no Birkat Kohanim");
				HalachaOutput("  no Avinu Malkeynu");
			} else {
				HalachaOutput("  Avinu Malkeynu");
			}
	}
	if (eighteen_blessings(today)) {
		if (no_takhanun(today)) {
			HalachaOutput("  no Takhanun");
		} else {
			if (isWeekday(today, Monday) || isWeekday(today, Thursday)) {
				HalachaOutput("  long Takhanun");
			} else {
				HalachaOutput("  Takhanun");
			}
		}
	}
	if (isDay(today, "Purim"))
		HalachaOutput("Megilat Ester");
	else if (sabbath(today) && (today >= h_holiday(today, "PESAKH_II")) &&
			(today <= h_holiday(today, "PESAKH_VII")))
		HalachaOutput("  Megilat Shir haShirim");
	else if (isDay(today, "Shavuot_I"))
		HalachaOutput("  Megilat Ruth");
	else if (sabbath(today) && (today >= h_holiday(today, "SUKKOT_II")) &&
			(today <= h_holiday(today, "SUKKOT_VII")))
		HalachaOutput("  Megilat Kohelet");

if (khol_haMoed(today) && !sabbath(today)) {
	HalachaOutput("  Remove tefilin (if wearing)");
}
if (today >= h_holiday(today, "SUKKOT_I") && today <= h_holiday(today,
		"SUKKOT_VII") && ! sabbath(today))
	HalachaOutput("  Lulav and etrog");
if (festival(today) || khannuka(today)) {
	if (today == h_holiday(today, "PESAKH_VII") || today == h_holiday(today,
			"PESAKH_VIII"))
		HalachaOutput("  short Hallel");
	else
		HalachaOutput("  full Hallel");
} else if (day_in_month(today)==30 || (day_in_month(today)==1 &&
		month(today)!=Tishri) || khol_haMoed(today))
	HalachaOutput("  short Hallel");

if ((diaspora && isDay(today, "Shemini_atseres_II")) ||
  (israel && isDay(today, "Shemini_atseres_I")))
  	HalachaOutput("Hakafot");

if (wantMusaf(today) || isDay(today, "Purim") || isDay(today, "tisha_beAv") ||
		isWeekday(today, Monday) || isWeekday(today, Thursday) ||
		isFastday(today) || khanukah(today)) {
	HalachaOutput("Torah reading");
	// count sifrey tora, aliyot
	if (sabbath(today)) {
		aliyot = 7;
		sefers = 1;
		if (named_shabbat(today)) sefers += 1;
		if (rosh_khodesh(today)) sefers += 1;
		if (khanukah(today)) sefers += 1;
		if (rosh_haShana(today) || yom_kippur(today) || festival(today) ||
				khol_haMoed(today))
			sefers += 1;
	} else if (rosh_khodesh(today)) {
		aliyot = 4;
		sefers = 1;
		if (khanukah(today)) sefers += 1;
	} else if (khanukah(today)) {
		aliyot = 3;
		sefers = 1;
	} else if (festival(today)) {
		aliyot = 5;
		sefers = 2;
	} else if (khol_haMoed(today)) {
		aliyot = 4;
		if (today >= h_holiday(today, "SUKKOT_I") &&
				today <= h_holiday(today, "SUKKOT_VII"))
			sefers = 1;
		else
			sefers = 2;
	} else if (rosh_haShana(today)) {
		aliyot = 5;
		sefers = 2;
	} else if (yom_kippur(today)) {
		aliyot = 6;
		sefers = 2;
	} else { // ordinary Monday or Thursday
		aliyot = 3;
		sefers = 1;
	}
	sprintf(outbuffer, "  %d %s torah; %d aliyot", sefers,
		sefers == 1 ? "sefer" : "sifrey", aliyot);
	HalachaOutput(outbuffer);
	outbuffer[0] = 0;
	if (GetTorahSectionShabbat(today, &aidTorah[0], &aidTorah[1], &aidTorah[2]))
	{
		int i; // portion number
		for (i = 0; i < 3; i++) { // each portion
			GetJewishTorahSectionName(aidTorah[i], str);
			append_str(outbuffer, "      ", ", ", str);
			GetJewishShabbatSectionName(aidTorah[i], str);
			append_str(outbuffer, "      ", ", ", str);
		} // each portion
	}
	GetSpecialDay(today, str);
	append_str(outbuffer, "      ", ", ", str);
	if (*outbuffer) HalachaOutput(outbuffer);
	if (isDay(today, "Shavuot_I")) {
		if (style(ashkenazi))
			HalachaOutput("  Akdamut");
		else 
			HalachaOutput("  Ketuva");
	}
	if (isDay(today, "Shavuot_II") && style(ashkenazi) && diaspora)
		HalachaOutput("  Yetsiv Pitgam");
	if (sabbath(today) || festival(today) || high_holiday(today) ||
			tisha_beAv(today))
		HalachaOutput("  Haftarah");
	if (tisha_beAv(today)) {
		HalachaOutput("  Kinot");
		HalachaOutput("  Megilat Eykha (some congregations)");
	}
	if (wantBirkatHakhodesh(today)) {
		HalachaOutput("  Birkat haKhodesh");
		MoladRetrieveNextSimple(str, 2, today);
		HalachaOutput(str);
	}
	if (sabbath(today)) { // compute Av haRakhamim
		if (today > h_holiday(today, "PESAKH_VII") &&
				today < h_holiday(today, "SHAVUOT_I"))
			HalachaOutput("  Av haRakhamim");
		else if (!(no_takhanun(today) || wantBirkatHakhodesh(today)))
			HalachaOutput("  Av haRakhamim");
		else {
			HalachaOutput("  no Av haRakhamim");
		}
	} // compute Av haRakhamim
	if ((diaspora && (isDay(today, "Pesakh_VIII") || isDay(today, "Shavuot_II")
			|| isDay(today, "Shemini_atseres_II"))) ||
			(israel && (isDay(today, "Pesakh_VII") || isDay(today, "Shavuot_I")
			|| isDay(today, "Shemini_atseres_I"))))
	  	HalachaOutput("  Yizkor");
	if (rosh_haShana(today)) {
		if (sabbath(today))
			HalachaOutput("  no Shofar");
		else 
			HalachaOutput("  Shofar");
	}
} // Torah reading

if (!sabbath(today) && !(festival(today)) && !(high_holiday(today))) {
	if ( tisha_beAv(today) || today==h_holiday(today, "SUKKOT_VII") ||
			khanukah(today) || rosh_khodesh(today)) {
		HalachaOutput("  no LaMenatseyakh");
		if (rosh_khodesh(today))
			HalachaOutput("  remove tefilin before Musaf");
		else if (tisha_beAv(today)) {
			HalachaOutput("  no veAni Zot Briti");
			HalachaOutput("  Full Kaddish without Titkabel");
		}
	}
}

if (wantMusaf(today)) {
	HalachaOutput("Musaf");
	if (today==h_holiday(today, "SUKKOT_VII")) {
		HalachaOutput("  Cantor wears kittel");
	}
	if (today >= h_holiday(today, "ROSH_HASHANA_I") &&
			today <= h_holiday(today, "YOM_KIPPUR"))
		HalachaOutput("  Zokhreynu leKhayim");
	if (today == h_holiday(today, "SHEMINI_ATSERES_I"))
		HalachaOutput("  Tefilat Geshem");
	else if (today == h_holiday(today, "PESAKH_I"))
		HalachaOutput("  Tefilat Tal");
	if (today >= h_holiday(today, "SUKKOT_I") &&
			today <= h_holiday(today, "SUKKOT_VII")) {
		if (sabbath(today)) {
			HalachaOutput("  Hoshanot: no procession");
			HalachaOutput("     Ark opened but no Torah removed");
		} else if (today < h_holiday(today, "SUKKOT_VII")) {
			HalachaOutput("  Hoshanot: one sefer torah");
		} else {
			HalachaOutput("  Hoshanot: all sefer torahs");
			HalachaOutput("    Seven hakafot");
			HalachaOutput("  Beat the willow branches.");
		}
	}
	if (khannuka(today)) HalachaOutput("  Al haNisim");
}

if (!sabbath(today) && today >= hebrDate(Elul, 1, today) &&		today <= hebrDate(Elul, 29, today)) {
	if (today == hebrDate(Elul, 29, today)) 
		HalachaOutput("  no Shofar");
	else
		HalachaOutput("  Shofar");
}
if (penitential(today)) {
	if (today == h_holiday(today, "SUKKOT_VII")) {
		HalachaOutput("  LeDavid haShem Uri (Psalm 27, last time)");
	} else {
		HalachaOutput("  LeDavid haShem Uri (Psalm 27)");
	}
} else if (khannuka(today)) {
	HalachaOutput("  Mizmor Shir Khannukat (Psalm 30)");
}

if (today == h_holiday(today, "ROSH_HASHANA_I")) {
	if (sabbath(today)) {
		HalachaOutput("no Tashlikh (wait until tomorrow)");
	} else {
		HalachaOutput("Tashlikh");
	}
}
if (today-1 == h_holiday(today, "ROSH_HASHANA_I") && sabbath((today-1))) {
	HalachaOutput("Tashlikh");
}

HalachaOutput("Minkha");
	if (tisha_beAv(today)) {
		HalachaOutput("  Tallit and tefillin with berakha");
	}
	if (isFastday(today) || sabbath(today)) {
		HalachaOutput("  Torah reading: 1 sefer torah, 3 aliyot");
		if (yom_kippur(today))
			HalachaOutput("  Haftarah (Jonah)");
		else if (!sabbath(today))
			HalachaOutput("  Haftarah (Isaiah 55:6 - 56:8)");
	}
	if (today >= h_holiday(today, "ROSH_HASHANA_I")
			&& today <= h_holiday(today, "YOM_KIPPUR"))
		HalachaOutput("  Zokhreynu leKhayim");
	if (today == h_holiday(today, "SHEMINI_ATSERES_I"))
		HalachaOutput("  Mashiv haRuakh");
	else if (today == h_holiday(today, "PESAKH_I")) {
		if (style(sephardic))
			HalachaOutput("  Morid haTal");
		else
			HalachaOutput("  no Mashiv haRuakh");
	}
	if (festival(today) || high_holiday(today) || rosh_khodesh(today) ||
			khol_haMoed(today))
		HalachaOutput("  Yaale veYavo");
	if (isFastday(today) && !high_holiday(today)) {
		HalachaOutput("  Aneynu");
		if (tisha_beAv(today)) {
			HalachaOutput("  conclude uVerushalayim with Nakhem");
		}
		HalachaOutput("  Birkat Kohanim (in repetition)");
		HalachaOutput("  Sim Shalom instead of Shalom Rav");
		if (tisha_beAv(today) || isDay(today, "taanit_esther")) {
			HalachaOutput("  no Avinu Malkeynu");
		} else {
			HalachaOutput("  Avinu Malkeynu");
		}
	}
	if (isDay(today, "Purim") || khannuka(today)) HalachaOutput("  Al haNisim");
	if (eighteen_blessings(today)) {
		if (! (no_takhanun(today) || no_takhanun(tomorrow)))
			HalachaOutput("  Takhanun");
		else
			HalachaOutput("  no Takhanun");
	}
	if (isDay(today, "yom_kippur")) {
		HalachaOutput("Neila");
		HalachaOutput("  Katveynu leKhayim");
	}

HalachaOutput("Maariv");
	GetSpecialDay(tomorrow, str);
	if (strcmp(str, "") != 0) {
		sprintf(outbuffer, "  %s", str);
		HalachaOutput(outbuffer);
	} else if (sabbath(tomorrow)) {
		HalachaOutput("  Kabbalat Shabbat");
	}
	if (khannuka(tomorrow) && !sabbath(today)) {
		HalachaOutput("  Light candles before Maariv");
		HalachaOutput("    in synagogue with blessings");
	}
	if (sabbath(today)) {
		if (festival(tomorrow) || rosh_haShana(tomorrow))
			HalachaOutput("  veTodiyenu");
		else
			HalachaOutput("  Ato Khonantanu");
	}
	if (tomorrow >= h_holiday(tomorrow, "ROSH_HASHANA_I") &&
			tomorrow <= h_holiday(tomorrow, "YOM_KIPPUR"))
		HalachaOutput("  Zokhreynu leKhayim");
	if (today == h_holiday(today, "SHEMINI_ATSERES_I"))
		HalachaOutput("  Mashiv haRuakh");
	else if (today == h_holiday(today, "PESAKH_I")) {
		if (style(sephardic))
			HalachaOutput("  Morid haTal");
		else
			HalachaOutput("  no Mashiv haRuakh");
	}
	if (eighteen_blessings(tomorrow) && !eighteen_blessings(today)) {
		if (tomorrow > h_holiday_prev(tomorrow, "PESAKH_I") &&
				tomorrow <= end_teyn_brokhe(today))
			HalachaOutput("  Teyn Berakha");
		else
			HalachaOutput("  Teyn Tal uMatar");
	}
	if (festival(tomorrow) || high_holiday(tomorrow) || rosh_khodesh(tomorrow)
			|| khol_haMoed(tomorrow))
		HalachaOutput("  Yaale veYavo");
	if (isDay(tomorrow, "Purim") || khannuka(tomorrow))
		HalachaOutput("  Al haNisim");
	if (isDay(today, "Purim"))
		HalachaOutput("  Megilat Ester");
        else if ((diaspora && isDay(tomorrow, "Shemini_atseres_II")) ||
        (israel && isDay(tomorrow, "Shemini_atseres_I")))
		HalachaOutput("  Hakafot");
	if (today > h_holiday(today, "PESAKH_II") &&
			today < h_holiday(today, "SHAVUOT_I"))
		HalachaOutput("  Sefirat haOmer");
	if (tisha_beAv(tomorrow)) {
		HalachaOutput("  Megilat Eykha");
		HalachaOutput("  Kinot");
		HalachaOutput("  Full Kaddish without Titkabel");
	}
	if (sabbath(today) || yom_kippur(today)) {
		if (khannuka(tomorrow)) {
			HalachaOutput("  Light Khannuka candles before Havdalah");
		}
		if (festival(tomorrow)) {
			HalachaOutput("  Havdalah during kiddush");
		} else if (tomorrow == h_holiday(tomorrow, "ROSH_HASHANA_II")) {
			HalachaOutput("  no Havdalah");
		} else {
			HalachaOutput("  Havdalah");
			if (!sabbath(today)) {
				HalachaOutput("    candle, but no introduction or spices");
			}
		}
	} else if (today == h_holiday(today, "ROSH_HASHANA_II") || 
			(!diaspora && (isDay(today, "Pesakh_VII") ||
				isDay(today, "Shavuot_I") ||
				isDay(today, "Shemini_atseres_I"))) ||
			(diaspora && \
				(isDay(today, "Pesakh_VIII") ||
				isDay(today, "Shavuot_II") ||
				isDay(today, "Shemini_atseres_II")))){
		HalachaOutput("  Havdalah");
		HalachaOutput("    no introduction, candle, or spices");
		if (sabbath(tomorrow)) {
			HalachaOutput("    haMavdil beyn Kodesh leKodesh");
		}
	}
	if (penitential(tomorrow))
		HalachaOutput("  LeDavid haShem Uri (Psalm 27)");
	else if (khannuka(tomorrow))
		HalachaOutput("  Mizmor Shir Khannukat (Psalm 30)");

if (sabbath(today) && today >= hebrDate(Elul, 23, today) &&		(today <= hebrDate(Elul, 28, today))) {
	HalachaOutput("Selikhot");
}

} // HalachaDo
