#ifndef __HALACHA2_H
#define __HALACHA2_H

#ifdef HALACHA2_INTERNAL
#  define HALACHA2_EXTERN
#else
#  define HALACHA2_EXTERN extern
#endif

#include "halacha.h"

#define Nisan           1
#define Sivan           3
#define Elul            6
#define Tishri          7
#define Heshvan         8

#define December        12

#define Monday          1
#define Thursday        4
#define Saturday        6

#define isWeekday(date, weekday) (((date % 7) == weekday) ? 1 : 0)
#define sabbath(date) ((date % 7) == Saturday)
#define style(value) (style == value)

HALACHA2_EXTERN int isDay(long date, char *holiday);
 
HALACHA2_EXTERN int day_in_month(long absDate);
HALACHA2_EXTERN long end_teyn_brokhe(long absDate);
HALACHA2_EXTERN int month(long absDate);
HALACHA2_EXTERN int civil_year(long absDate);

HALACHA2_EXTERN long gregDate(int month, int day, long date);
HALACHA2_EXTERN long hebrDate(int month, int day, long date);

HALACHA2_EXTERN long h_holiday(long absDate, char *name);
HALACHA2_EXTERN long h_holiday_prev(long absDate, char *name);

HALACHA2_EXTERN int high_holiday(long absDate);
HALACHA2_EXTERN int rosh_khodesh(long absDate);
HALACHA2_EXTERN int khol_haMoed(long absDate);
HALACHA2_EXTERN int khol_haMoed_Pesakh(long absDate);
HALACHA2_EXTERN int day_in_omer(long absDte);
HALACHA2_EXTERN int tisha_beAv(long absDate);
HALACHA2_EXTERN int Av_15(long absDate);
HALACHA2_EXTERN int khanukah(long absDate);
HALACHA2_EXTERN int tu_beshvat(long absDate);
HALACHA2_EXTERN int purim(long absDate);
HALACHA2_EXTERN int shushan_purim(long absDate);
HALACHA2_EXTERN int adar_14(long absDate);
HALACHA2_EXTERN int adar_15(long absDate);
HALACHA2_EXTERN int shabbat_zakhor(long absDate);
HALACHA2_EXTERN int shabbat_parah(long absDate);
HALACHA2_EXTERN int shabbat_haKhodesh(long absDate);
HALACHA2_EXTERN int shabbat_shekalim(long absDate);
HALACHA2_EXTERN int rosh_haShana(long absDate);

#endif

