#define HALACHATORAH_INTERNAL
#include "config.h"
#include "hebrcal.h"
#include "torahfull.h"
#include "halachatorah.h"

#define STR_MORNING     "Morning: "
#define STR_EVENING     "Afternoon: "

void HalachaTorahGetSplitted(char *startPos, char *destStr, int isEvening)
{
  int parenLevel;
  char *destStrLauf, *currentPos;

  parenLevel = 0;
  destStrLauf = destStr;
  currentPos = startPos;
  for (;;)
  {
    if (*currentPos == '(') parenLevel++;
    if (*currentPos == ')') parenLevel--;
    if ((*currentPos == 0) || (*currentPos == '\n'))
      break;
    if ((*currentPos == ';') && (parenLevel == 0) && (!isEvening))
      break;

    *destStrLauf++ = *currentPos;
    currentPos++;
  }
  *destStrLauf = 0;
}

void HalachaTorahSplit(char *sourceStr, char *morningStr, char *eveningStr)
{
  char *morningPos, *eveningPos;

  morningPos = strstr(sourceStr, STR_MORNING);
  eveningPos = strstr(sourceStr, STR_EVENING);
  if (!morningPos && !eveningPos)
  {
    strcpy(morningStr, sourceStr);
    strcpy(eveningStr, "");
  }
  else
  {
    strcpy(morningStr, "");
    strcpy(eveningStr, "");

    if (morningPos) morningPos += strlen(STR_MORNING);
    if (eveningPos) eveningPos += strlen(STR_EVENING);

    if (morningPos) HalachaTorahGetSplitted(morningPos, morningStr, 0);
    if (eveningPos) HalachaTorahGetSplitted(eveningPos, eveningStr, 1);
  }
}

HALACHATORAH_EXTERN void HalachaGetTorahReading(long today,
                                                char *outbufferTM,
                                                char *outbufferTE,
                                                char *outbufferHM,
                                                char *outbufferHE)
{	
  calDate dateToday;
  char torahStr[256], haphtarahStr[256];
  char torahMStr[256], torahEStr[256];
  char haphtarahMStr[256], haphtarahEStr[256];
          
  strcpy(outbufferTM, "");
  strcpy(outbufferTE, "");
  strcpy(outbufferHM, "");
  strcpy(outbufferHE, "");

  HebrcalForeignFromAbsolute(today, &dateToday);
  ParashGetQuickly(dateToday.day, dateToday.month, dateToday.year,
                   torahStr, haphtarahStr);
          
  if (strcmp(torahStr, "") != 0)
  {
    HalachaTorahSplit(torahStr, torahMStr, torahEStr);    
    if (strcmp(torahMStr, "") != 0)
      sprintf(outbufferTM, "    Torah reading:\n"
                           "      %s", torahMStr);
    if (strcmp(torahEStr, "") != 0)
      sprintf(outbufferTE, "    Torah reading:\n"
                           "      %s", torahEStr);
  }
  if (strcmp(haphtarahStr, "") != 0)
  {
    HalachaTorahSplit(haphtarahStr, haphtarahMStr, haphtarahEStr);
    if (strcmp(haphtarahMStr, "") != 0)
      sprintf(outbufferHM, "    Haftarah reading:\n"
                           "      %s", haphtarahMStr);
    if (strcmp(haphtarahEStr, "") != 0)
      sprintf(outbufferHE, "    Haftarah reading:\n"
                           "      %s", haphtarahEStr);
  }
}

