#include "config.h"

#include "date.h"
#include "hebrcal.h"
#include "misc.h"

int IsBlank(char *str)
{
  char *lauf;

  lauf = str;
  while (*lauf == ' ') lauf++;
  if (*lauf == 0)
    return 1;
  else
    return 0;
}

int GetOmerCount(long absDate)
{
  calDate dateHebrew, dateOmerStart;
  long omerStart, dayOfOmer;

  HebrcalForeignFromAbsolute(absDate, &dateHebrew);

  dateOmerStart.day   = 16;
  dateOmerStart.month = 1;
  dateOmerStart.year  = dateHebrew.year;
  omerStart = HebrcalAbsoluteFromForeign(&dateOmerStart);
  if (absDate >= omerStart)
  {
    dayOfOmer = absDate-omerStart+1;
    if (dayOfOmer <= 49)
      return (dayOfOmer);
  }

  return 0;
}

int IsDateRoshHodesh(long absDate)
{
  calDate date;

  HebrcalForeignFromAbsolute(absDate, &date);

  /* If the date is on Rosh HaShanah, return FALSE */
  if ((date.day == 1) && (date.month == 7))
    return 0;
  else
  {
    /* If the date is on a 30th or on a 1th, return TRUE */
    if ((date.day == 30) || (date.day == 1))
      return 1;
    else
      /* Else return FALSE */
      return 0;
  }
}

