#define __TORAH__

#include "config.h"

#include "date.h"
#include "hebrcal.h"
#include "settings.h"
#include "torahids.h"
#include "torahids2.h"
#include "torah.h"

#define YEARTYPE_A        0
#define YEARTYPE_B        1
#define YEARTYPE_C        2
#define YEARTYPE_D        3
#define YEARTYPE_E        4
#define YEARTYPE_F        5
#define YEARTYPE_G        6
#define YEARTYPE_H        7
#define YEARTYPE_I        8
#define YEARTYPE_J        9
#define YEARTYPE_K        10
#define YEARTYPE_L        11
#define YEARTYPE_M        12
#define YEARTYPE_N        13

#define YEARTYPE_INVALID  1000

/* Year Type A: 5726, 5753  */
#define MAXA 51

PARASHIOTH torahReadingsA[MAXA] =
  {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 24 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 25 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 35 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 36 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 37 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 48 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_YOM_KIPPUR,          ID_NULL,    ID_NULL},      /* 50 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 51 */

/* Year Type B: 5737, 5761 */
#define MAXB 50

PARASHIOTH torahReadingsB[MAXB] =
  {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_ZAHOR,   ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 23 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 24 */
   {ID_PESAH_VII,           ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 26 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 27 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 28 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 29 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 30 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 33 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 34 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 35 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 36 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 37 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 38 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 39 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 40 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 41 */
   {ID_EKEB,                ID_NULL,    ID_NULL},     /* 42 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 44 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 46 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 47 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 48 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 50 */

/* Year Type C: 5715, 5735 */
#define MAXC 52

PARASHIOTH torahReadingsCDiaspora[MAXC] =
  {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 24 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 25 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_SHAVUOTH_II,         ID_NULL,    ID_NULL},      /* 33 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 35 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 36 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 37 */
   {ID_HUKATH,              ID_BALAK,   ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 48 */
   {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 49 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 51 */
   {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 52 */

PARASHIOTH torahReadingsCIsrael[MAXC] =
  {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 24 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 25 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 35 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 36 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 37 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 48 */
   {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 49 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 51 */
   {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 52 */

/* Year Type D: 5701, 5704 */
#define MAXD 51

PARASHIOTH torahReadingsDDiaspora[MAXD] =
  {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_PARAH},     /* 22 */
   {ID_VAYIKRA,             ID_HAHODESH,ID_NULL},      /* 23 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 24 */
   {ID_PESAH_I,             ID_NULL,    ID_NULL},      /* 25 */
   {ID_PESAH_VIII,          ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 35 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 36 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 37 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 48 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 51 */

PARASHIOTH torahReadingsDIsrael[MAXD] =
  {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_PARAH},     /* 22 */
   {ID_VAYIKRA,             ID_HAHODESH,ID_NULL},      /* 23 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 24 */
   {ID_PESAH_I,             ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 26 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 27 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 28 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 29 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 35 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 36 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 37 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 48 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 51 */

/* Year Type E: 5732, 5739 */
#define MAXE 52

PARASHIOTH torahReadingsEDiaspora[MAXE] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 23 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 24 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_SHAVUOTH_II,         ID_NULL,    ID_NULL},      /* 33 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 35 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 36 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 37 */
   {ID_HUKATH,              ID_BALAK,   ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 48 */
   {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 49 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 51 */
   {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 52 */

PARASHIOTH torahReadingsEIsrael[MAXE] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 23 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 24 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 35 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 36 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 37 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 48 */
   {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 49 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 51 */
   {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 52 */

/* Year Type F: 5754, 5785 */
#define MAXF 52

PARASHIOTH torahReadingsF[MAXF] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_SHEKALIM,ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PARAH,   ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_HAHODESH,ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 24 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 25 */
   {ID_PESAH_VII,           ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 35 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 36 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 37 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 38 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 41 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 42 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 43 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 45 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 47 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 48 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 51 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 52 */

/* Year Type G: 5716, 5743  */
#define MAXG 51

PARASHIOTH torahReadingsG[MAXG] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_SHEKALIM,ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_ZAHOR,   ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_PARAH,   ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_PEKUDE,  ID_HAHODESH},  /* 22 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 24 */
   {ID_TSAV,                ID_HAGGADOL,ID_NULL},      /* 25 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 26 */
   {ID_SHEMINI,             ID_NULL,    ID_NULL},      /* 27 */
   {ID_TAZRIANG,           ID_METSORANG,ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_KEDOSHIM,ID_NULL},      /* 29 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 30 */
   {ID_BEHAR,            ID_BEHUKKOTHAI,ID_NULL},      /* 31 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 35 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 36 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 37 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 38 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 39 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 40 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 41 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 42 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 43 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 44 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 45 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 46 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 47 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 48 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_YOM_KIPPUR,          ID_NULL,    ID_NULL},      /* 50 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 51 */

/* Year Type H: 5817, 5820 */
#define MAXH 55

PARASHIOTH torahReadingsHDiaspora[MAXH] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
   {ID_TSAV,                ID_PARAH,   ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_HAHODESH,ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_NULL,    ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 29 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_SHAVUOTH_II,         ID_NULL,    ID_NULL},      /* 36 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 37 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 38 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 39 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 40 */
   {ID_HUKATH,              ID_BALAK,   ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 43 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 44 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 45 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 46 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 48 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 50 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 51 */
   {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 52 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 54 */
   {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 55 */

PARASHIOTH torahReadingsHIsrael[MAXH] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
   {ID_TSAV,                ID_PARAH,   ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_HAHODESH,ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_NULL,    ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 29 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 43 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 44 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 45 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 46 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 48 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 50 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 51 */
   {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 52 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 54 */
   {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 55 */

/* Year Type I: 5714, 5741 */
#define MAXI 55

PARASHIOTH torahReadingsI[MAXI] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_NULL,    ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_SHEKALIM,ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
   {ID_TSAV,                ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_PARAH,   ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_HAHODESH,ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_NULL,    ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_HAGGADOL,ID_NULL},      /* 29 */
   {ID_PESAH_VII,           ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_NULL,    ID_NULL},      /* 43 */
   {ID_MASEH,               ID_NULL,    ID_NULL},      /* 44 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 46 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 48 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 51 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 52 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 54 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 55 */

/* Year Type J: 5733, 5757 */
#define MAXJ 54

PARASHIOTH torahReadingsJ[MAXJ] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
   {ID_TSAV,                ID_PARAH,   ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_HAHODESH,ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_NULL,    ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 29 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 43 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 44 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 45 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 46 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 48 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 50 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 51 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 52 */
   {ID_YOM_KIPPUR,          ID_NULL,    ID_NULL},      /* 53 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 54 */

/* Year Type K: 5711, 5738 */
#define MAXK 55

PARASHIOTH torahReadingsKDiaspora[MAXK] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
   {ID_TSAV,                ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_PARAH,   ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_HAHODESH,ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_PESAH_I,             ID_NULL,    ID_NULL},      /* 29 */
   {ID_PESAH_VIII,          ID_NULL,    ID_NULL},      /* 30 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 31 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 35 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 36 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 37 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 38 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 39 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 40 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 41 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 42 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 43 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 44 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 46 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 48 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 51 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 52 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 54 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 55 */

PARASHIOTH torahReadingsKIsrael[MAXK] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
   {ID_TSAV,                ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_PARAH,   ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_HAHODESH,ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_PESAH_I,             ID_NULL,    ID_NULL},      /* 29 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_NULL,    ID_NULL},      /* 43 */
   {ID_MASEH,               ID_NULL,    ID_NULL},      /* 44 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 46 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 48 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 51 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 52 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 54 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 55 */

/* Year Type L: 5725, 5752 */
#define MAXL 55

PARASHIOTH torahReadingsLDiaspora[MAXL] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,  ID_NULL},      /* 24 */
   {ID_TSAV,                ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_PARAH,   ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_HAHODESH,ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_PESAH_I,             ID_NULL,    ID_NULL},      /* 29 */
   {ID_PESAH_VIII,          ID_NULL,    ID_NULL},      /* 30 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 31 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 32 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 35 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 36 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 37 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 38 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 39 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 40 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 41 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 42 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 43 */
   {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 44 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 46 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 48 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 51 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 52 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 54 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 55 */

PARASHIOTH torahReadingsLIsrael[MAXL] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_ZAHOR,  ID_NULL},      /* 24 */
   {ID_TSAV,                ID_NULL,    ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_PARAH,   ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_HAHODESH,ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
   {ID_PESAH_I,             ID_NULL,    ID_NULL},      /* 29 */
   {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_NULL,    ID_NULL},      /* 43 */
   {ID_MASEH,               ID_NULL,    ID_NULL},      /* 44 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 46 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 48 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 51 */
   {ID_NITSABIM,            ID_NULL,    ID_NULL},      /* 52 */
   {ID_VAYELEH,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 54 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 55 */

/* Year Type M: 5771, 5774 */
#define MAXM 55

PARASHIOTH torahReadingsM[MAXM] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
   {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
   {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
   {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
   {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
   {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
   {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
   {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
   {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
   {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
   {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
   {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
   {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
   {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
   {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
   {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
   {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
   {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
   {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
   {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
   {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
   {ID_VAYAKHEL,            ID_NULL,    ID_NULL},      /* 22 */
   {ID_PEKUDE,              ID_SHEKALIM,ID_NULL},      /* 23 */
   {ID_VAYIKRA,             ID_NULL,    ID_NULL},      /* 24 */
   {ID_TSAV,                ID_ZAHOR,   ID_NULL},      /* 25 */
   {ID_SHEMINI,             ID_PARAH,   ID_NULL},      /* 26 */
   {ID_TAZRIANG,            ID_HAHODESH,ID_NULL},      /* 27 */
   {ID_METSORANG,           ID_NULL,    ID_NULL},      /* 28 */
   {ID_AHAREMOTH,           ID_HAGGADOL,ID_NULL},      /* 29 */
   {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 30 */
   {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
   {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
   {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
   {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
   {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
   {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
   {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
   {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
   {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
   {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
   {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
   {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
   {ID_MATOTH,              ID_NULL,    ID_NULL},      /* 43 */
   {ID_MASEH,               ID_NULL,    ID_NULL},      /* 44 */
   {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 45 */
   {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 46 */
   {ID_EKEB,                ID_NULL,    ID_NULL},      /* 47 */
   {ID_REEH,                ID_NULL,    ID_NULL},      /* 48 */
   {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 49 */
   {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 50 */
   {ID_KITABO,              ID_NULL,    ID_NULL},      /* 51 */
   {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 52 */
   {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 53 */
   {ID_YOM_KIPPUR,          ID_NULL,    ID_NULL},      /* 54 */
   {ID_HOL_HAMOED_SUCCOTH,  ID_NULL,    ID_NULL}};     /* 55 */

/* Year Type N: 5665, 5787 */
#define MAXN 55

PARASHIOTH torahReadingsNDiaspora[MAXN] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
  {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
  {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
  {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
  {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
  {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
  {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
  {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
  {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
  {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
  {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
  {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
  {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
  {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
  {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
  {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
  {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
  {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
  {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
  {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
  {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
  {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
  {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
  {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
  {ID_TSAV,                ID_PARAH,   ID_NULL},      /* 25 */
  {ID_SHEMINI,             ID_HAHODESH,ID_NULL},      /* 26 */
  {ID_TAZRIANG,            ID_NULL,    ID_NULL},      /* 27 */
  {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
  {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 29 */
  {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
  {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
  {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
  {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
  {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
  {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
  {ID_SHAVUOTH_II,         ID_NULL,    ID_NULL},      /* 36 */
  {ID_NASO,                ID_NULL,    ID_NULL},      /* 37 */
  {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 38 */
  {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 39 */
  {ID_KORAH,               ID_NULL,    ID_NULL},      /* 40 */
  {ID_HUKATH,              ID_BALAK,   ID_NULL},      /* 41 */
  {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
  {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 43 */
  {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 44 */
  {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 45 */
  {ID_EKEB,                ID_NULL,    ID_NULL},      /* 46 */
  {ID_REEH,                ID_NULL,    ID_NULL},      /* 47 */
  {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 48 */
  {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 49 */
  {ID_KITABO,              ID_NULL,    ID_NULL},      /* 50 */
  {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 51 */
  {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 52 */
  {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 53 */
  {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 54 */
  {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 55 */

PARASHIOTH torahReadingsNIsrael[MAXN] =
 {{ID_BERESHITH,           ID_NULL,    ID_NULL},      /*  1 */
  {ID_NOAH,                ID_NULL,    ID_NULL},      /*  2 */
  {ID_LEHLEHA,             ID_NULL,    ID_NULL},      /*  3 */
  {ID_VAYERA,              ID_NULL,    ID_NULL},      /*  4 */
  {ID_HAYESARAH,           ID_NULL,    ID_NULL},      /*  5 */
  {ID_TOLEDOTH,            ID_NULL,    ID_NULL},      /*  6 */
  {ID_VAYETSE,             ID_NULL,    ID_NULL},      /*  7 */
  {ID_VAYISHLAH,           ID_NULL,    ID_NULL},      /*  8 */
  {ID_VAYESHEB,            ID_NULL,    ID_NULL},      /*  9 */
  {ID_MIKKETS,             ID_NULL,    ID_NULL},      /* 10 */
  {ID_VAYIGGASH,           ID_NULL,    ID_NULL},      /* 11 */
  {ID_VAYHEE,              ID_NULL,    ID_NULL},      /* 12 */
  {ID_SHEMOTH,             ID_NULL,    ID_NULL},      /* 13 */
  {ID_VAERA,               ID_NULL,    ID_NULL},      /* 14 */
  {ID_BO,                  ID_NULL,    ID_NULL},      /* 15 */
  {ID_BESHALLAH,           ID_NULL,    ID_NULL},      /* 16 */
  {ID_YITHRO,              ID_NULL,    ID_NULL},      /* 17 */
  {ID_MISHPATIM,           ID_NULL,    ID_NULL},      /* 18 */
  {ID_TERUMAH,             ID_NULL,    ID_NULL},      /* 19 */
  {ID_TETSAVVEH,           ID_NULL,    ID_NULL},      /* 20 */
  {ID_KITISSA,             ID_NULL,    ID_NULL},      /* 21 */
  {ID_VAYAKHEL,            ID_SHEKALIM,ID_NULL},      /* 22 */
  {ID_PEKUDE,              ID_NULL,    ID_NULL},      /* 23 */
  {ID_VAYIKRA,             ID_ZAHOR,   ID_NULL},      /* 24 */
  {ID_TSAV,                ID_PARAH,   ID_NULL},      /* 25 */
  {ID_SHEMINI,             ID_HAHODESH,ID_NULL},      /* 26 */
  {ID_TAZRIANG,            ID_NULL,    ID_NULL},      /* 27 */
  {ID_METSORANG,           ID_HAGGADOL,ID_NULL},      /* 28 */
  {ID_HOL_HAMOED_PESAH,    ID_NULL,    ID_NULL},      /* 29 */
  {ID_AHAREMOTH,           ID_NULL,    ID_NULL},      /* 30 */
  {ID_KEDOSHIM,            ID_NULL,    ID_NULL},      /* 31 */
  {ID_EMOR,                ID_NULL,    ID_NULL},      /* 32 */
  {ID_BEHAR,               ID_NULL,    ID_NULL},      /* 33 */
  {ID_BEHUKKOTHAI,         ID_NULL,    ID_NULL},      /* 34 */
  {ID_BEMIDBAR,            ID_NULL,    ID_NULL},      /* 35 */
  {ID_NASO,                ID_NULL,    ID_NULL},      /* 36 */
  {ID_BEHAALOTEHA,         ID_NULL,    ID_NULL},      /* 37 */
  {ID_SHELAHLEHA,          ID_NULL,    ID_NULL},      /* 38 */
  {ID_KORAH,               ID_NULL,    ID_NULL},      /* 39 */
  {ID_HUKATH,              ID_NULL,    ID_NULL},      /* 40 */
  {ID_BALAK,               ID_NULL,    ID_NULL},      /* 41 */
  {ID_PINHAS,              ID_NULL,    ID_NULL},      /* 42 */
  {ID_MATOTH,              ID_MASEH,   ID_NULL},      /* 43 */
  {ID_DEBARIM,             ID_NULL,    ID_NULL},      /* 44 */
  {ID_VAETHANAN,           ID_NULL,    ID_NULL},      /* 45 */
  {ID_EKEB,                ID_NULL,    ID_NULL},      /* 46 */
  {ID_REEH,                ID_NULL,    ID_NULL},      /* 47 */
  {ID_SHOFETIM,            ID_NULL,    ID_NULL},      /* 48 */
  {ID_KITETSE,             ID_NULL,    ID_NULL},      /* 49 */
  {ID_KITABO,              ID_NULL,    ID_NULL},      /* 50 */
  {ID_NITSABIM,            ID_VAYELEH, ID_NULL},      /* 51 */
  {ID_ROSH_HASHANAH_I,     ID_NULL,    ID_NULL},      /* 52 */
  {ID_HAAZINU,             ID_NULL,    ID_NULL},      /* 53 */
  {ID_SUCCOTH_I,           ID_NULL,    ID_NULL},      /* 54 */
  {ID_SHEMINI_AZERETH,     ID_NULL,    ID_NULL}};     /* 55 */

typedef struct tagYEARTYPE
{
  long roshHaShanahWeekday;
  long lengthOfYear;
  long pesahWeekday;
} YEARTYPE;

YEARTYPE YearTypes[14] =
 {{DAY_MONDAY,   353, DAY_TUESDAY},     /* A */
  {DAY_SATURDAY, 353, DAY_SUNDAY},      /* B */
  {DAY_TUESDAY,  354, DAY_THURSDAY},    /* C */
  {DAY_THURSDAY, 354, DAY_SATURDAY},    /* D */
  {DAY_MONDAY,   355, DAY_THURSDAY},    /* E */
  {DAY_THURSDAY, 355, DAY_SUNDAY},      /* F */
  {DAY_SATURDAY, 355, DAY_TUESDAY},     /* G */

  {DAY_MONDAY,   383, DAY_THURSDAY},    /* H */
  {DAY_THURSDAY, 383, DAY_SUNDAY},      /* I */
  {DAY_SATURDAY, 383, DAY_TUESDAY},     /* J */
  {DAY_TUESDAY,  384, DAY_SATURDAY},    /* K */
  {DAY_MONDAY,   385, DAY_SATURDAY},    /* L */
  {DAY_THURSDAY, 385, DAY_TUESDAY},     /* M */
  {DAY_SATURDAY, 385, DAY_THURSDAY}};   /* N */

int TorahGetYearType(int hebrewYear)
{
  calDate dateBegin, dateEnd, datePesah;
  long beginDate, endDate, pesahDate, countOfDays;
  long roshHaShanah, pesah;
  int i;

  dateBegin.day   = 1;
  dateBegin.month = 7;
  dateBegin.year  = hebrewYear;
  beginDate = HebrcalAbsoluteFromForeign(&dateBegin);
  roshHaShanah = GetWeekday(beginDate);

  dateEnd.day   = 1;
  dateEnd.month = 7;
  dateEnd.year  = hebrewYear+1;
  endDate = HebrcalAbsoluteFromForeign(&dateEnd);

  countOfDays = endDate-beginDate;

  datePesah.day   = 15;
  datePesah.month = 1;
  datePesah.year  = hebrewYear;
  pesahDate = HebrcalAbsoluteFromForeign(&datePesah);
  pesah = GetWeekday(pesahDate);

  for (i = 0; i < 14; i++)
  {
    if ((YearTypes[i].roshHaShanahWeekday == roshHaShanah) &&
        (YearTypes[i].lengthOfYear == countOfDays) &&
        (YearTypes[i].pesahWeekday == pesah))
      return (i);
  }
  return (YEARTYPE_INVALID);
}

long DetermineBereshith(int hebrewYear)
{
  calDate dateSimchatTorah;
  long simchatTorah;

  dateSimchatTorah.day   = 23;
  dateSimchatTorah.month = 7;
  dateSimchatTorah.year  = hebrewYear;
  simchatTorah = HebrcalAbsoluteFromForeign(&dateSimchatTorah);
  while (GetWeekday(simchatTorah) != DAY_SATURDAY)
    simchatTorah++;
  return (simchatTorah);
}

PARASHIOTH* ParashiothDiaspora[] = {
  &torahReadingsA[0],
  &torahReadingsB[0],
  &torahReadingsCDiaspora[0],
  &torahReadingsDDiaspora[0],
  &torahReadingsEDiaspora[0],
  &torahReadingsF[0],
  &torahReadingsG[0],
  &torahReadingsHDiaspora[0],
  &torahReadingsI[0],
  &torahReadingsJ[0],
  &torahReadingsKDiaspora[0],
  &torahReadingsLDiaspora[0],
  &torahReadingsM[0],
  &torahReadingsNDiaspora[0]};

PARASHIOTH* ParashiothIsrael[] = {
  &torahReadingsA[0],
  &torahReadingsB[0],
  &torahReadingsCIsrael[0],
  &torahReadingsDIsrael[0],
  &torahReadingsEIsrael[0],
  &torahReadingsF[0],
  &torahReadingsG[0],
  &torahReadingsHIsrael[0],
  &torahReadingsI[0],
  &torahReadingsJ[0],
  &torahReadingsKIsrael[0],
  &torahReadingsLIsrael[0],
  &torahReadingsM[0],
  &torahReadingsNIsrael[0]};

int GetTorahSectionShabbat(long hebrewDate, int *id1, int *id2, int *id3)
{
  calDate dateHebrew, dateRoshHaShanah;
  long roshHaShanahDate, bereshithDate;
  int referenceYear, yearType, weekNo;
  PARASHIOTH* parashioth;

  if (GetWeekday(hebrewDate) != DAY_SATURDAY)
    return 0;

  HebrcalForeignFromAbsolute(hebrewDate, &dateHebrew);

  dateRoshHaShanah.day   = 1;
  dateRoshHaShanah.month = 7;
  dateRoshHaShanah.year  = dateHebrew.year;
  roshHaShanahDate = HebrcalAbsoluteFromForeign(&dateRoshHaShanah);    

  bereshithDate = DetermineBereshith(dateHebrew.year);
  if (hebrewDate < bereshithDate)
    referenceYear = dateHebrew.year-1;
  else
    referenceYear = dateHebrew.year;
  yearType = TorahGetYearType(referenceYear);
  if (yearType == YEARTYPE_INVALID)
    return 0;

  bereshithDate = DetermineBereshith(referenceYear);
  weekNo = (hebrewDate-bereshithDate)/7;

  if (diasporaGetFlag())
    parashioth = ParashiothDiaspora[yearType];
  else
    parashioth = ParashiothIsrael[yearType];
  parashioth = parashioth + weekNo;
  *id1 = parashioth->id1;
  *id2 = parashioth->id2;
  *id3 = parashioth->id3;
  
  return 1;
}

