#ifndef __TORAHIDS2_H
#define __TORAHIDS2_H

#ifdef __TORAH__
#  define TORAH_EXTERN
#else
#  define TORAH_EXTERN extern
#endif

#define ID_NULL                       1000

#define ID_SIMHATHTORAH               53
#define ID_SIMHATHTORAH_2             54
#define ID_SIMHATHTORAH_3             55

#define ID_ROSH_HODESH_SHABBAT        60

#define ID_ROSH_HASHANAH_I            70
#define ID_ROSH_HASHANAH_II           71
#define ID_FAST_OF_GEDALIAH           72
#define ID_YOM_KIPPUR                 73
#define ID_SUCCOTH_I                  74
#define ID_SUCCOTH_II                 75
#define ID_SUCCOTH_III_NO_SHABBAT     76
#define ID_SUCCOTH_III                77
#define ID_SUCCOTH_IV                 78
#define ID_SUCCOTH_V_NO_SHABBAT       79
#define ID_SUCCOTH_V                  80
#define ID_SUCCOTH_VI_NO_SHABBAT      81
#define ID_SUCCOTH_VI                 82
#define ID_HOSHANAH_RABBAH            83
#define ID_HOL_HAMOED_SUCCOTH         84
#define ID_SHEMINI_AZERETH_1          85
#define ID_FAST_OF_ESTHER             86
#define ID_PURIM                      87
#define ID_FAST_OF_TEVET_10           88
#define ID_PESAH_I                    89
#define ID_HOL_HAMOED_PESAH           90
#define ID_PESAH_VII                  91
#define ID_PESAH_VIII                 92
#define ID_PESAH_VIII_NO_SHABBAT      93
#define ID_SHAVUOTH_I                 94
#define ID_SHAVUOTH_II_NO_SHABBAT     95 
#define ID_SHAVUOTH_II                96
#define ID_YOM_HAATZMAUT              97
#define ID_FAST_OF_TAMMUZ_17          98
#define ID_FAST_OF_TISHA_BAV          99
#define ID_CHANUKKAH_I               100
#define ID_CHANUKKAH_II              101
#define ID_CHANUKKAH_III             102
#define ID_CHANUKKAH_IV              103
#define ID_CHANUKKAH_V               104
#define ID_CHANUKKAH_VI              105
#define ID_CHANUKKAH_VI_ROSH_HODESH  106
#define ID_CHANUKKAH_VII             107
#define ID_CHANUKKAH_VII_ROSH_HODESH 108
#define ID_CHANUKKAH_VIII            109
#define ID_SECOND_SHABBAT_CHANUKKAH  110
#define ID_ROSH_HODESH               111
#define ID_PESAH_II                  112
#define ID_PESAH_III                 113
#define ID_PESAH_IV                  114
#define ID_PESAH_IV_NOT_SUNDAY       115
#define ID_PESAH_IV_SUNDAY           116
#define ID_PESAH_V                   117
#define ID_PESAH_V_NOT_MONDAY        118
#define ID_PESAH_V_MONDAY            119
#define ID_PESAH_VI                  120

#define ID_SHEMINI_AZERETH           200
#define ID_SHEMINI_AZERETH_2         201
#define ID_SHEMINI_AZERETH_3         202

#define ID_SPECIAL_1                 300
#define ID_SPECIAL_2                 301
#define ID_SPECIAL_3                 302
#define ID_SPECIAL_4                 303
#define ID_SPECIAL_5                 304
#define ID_SPECIAL_6                 305
#define ID_SPECIAL_7                 306
#define ID_SPECIAL_8                 307
#define ID_SPECIAL_8A                308
#define ID_SPECIAL_9                 309
#define ID_SPECIAL_10                310
#define ID_SPECIAL_11                311
#define ID_SPECIAL_12                312

#define YEARTYPE_A        0
#define YEARTYPE_B        1
#define YEARTYPE_C        2
#define YEARTYPE_D        3
#define YEARTYPE_E        4
#define YEARTYPE_F        5
#define YEARTYPE_G        6
#define YEARTYPE_H        7
#define YEARTYPE_I        8
#define YEARTYPE_J        9
#define YEARTYPE_K        10
#define YEARTYPE_L        11
#define YEARTYPE_M        12
#define YEARTYPE_N        13

#define YEARTYPE_INVALID  1000

typedef struct tagPARASHIOTH
{
  int id1;
  int id2;
  int id3;
} PARASHIOTH;

#define MAXA 51

TORAH_EXTERN PARASHIOTH torahReadingsA[MAXA];

#define MAXB 50

TORAH_EXTERN PARASHIOTH torahReadingsB[MAXB];

#define MAXC 52

TORAH_EXTERN PARASHIOTH torahReadingsCDiaspora[MAXC];
TORAH_EXTERN PARASHIOTH torahReadingsCIsrael[MAXC];

#define MAXD 51

TORAH_EXTERN PARASHIOTH torahReadingsDDiaspora[MAXD];
TORAH_EXTERN PARASHIOTH torahReadingsDIsrael[MAXD];

#define MAXE 52

TORAH_EXTERN PARASHIOTH torahReadingsEDiaspora[MAXE];
TORAH_EXTERN PARASHIOTH torahReadingsEIsrael[MAXE];

#define MAXF 52

TORAH_EXTERN PARASHIOTH torahReadingsF[MAXF];

#define MAXG 51

TORAH_EXTERN PARASHIOTH torahReadingsG[MAXG];

#define MAXH 55

TORAH_EXTERN PARASHIOTH torahReadingsHDiaspora[MAXH];
TORAH_EXTERN PARASHIOTH torahReadingsHIsrael[MAXH];

#define MAXI 55

TORAH_EXTERN PARASHIOTH torahReadingsI[MAXI];

#define MAXJ 54

TORAH_EXTERN PARASHIOTH torahReadingsJ[MAXJ];

#define MAXK 55

TORAH_EXTERN PARASHIOTH torahReadingsKDiaspora[MAXK];
TORAH_EXTERN PARASHIOTH torahReadingsKIsrael[MAXK];

#define MAXL 55

TORAH_EXTERN PARASHIOTH torahReadingsLDiaspora[MAXL];
TORAH_EXTERN PARASHIOTH torahReadingsLIsrael[MAXL];

#define MAXM 55

TORAH_EXTERN PARASHIOTH torahReadingsM[MAXM];

#define MAXN 55

TORAH_EXTERN PARASHIOTH torahReadingsNDiaspora[MAXN];
TORAH_EXTERN PARASHIOTH torahReadingsNIsrael[MAXN];

#define uTorahReadingsA            torahReadingsA
#define uTorahReadingsB            torahReadingsB
#define uTorahReadingsCDiaspora    torahReadingsCDiaspora
#define uTorahReadingsCIsrael      torahReadingsCIsrael
#define uTorahReadingsDDiaspora    torahReadingsDDiaspora
#define uTorahReadingsDIsrael      torahReadingsDIsrael
#define uTorahReadingsEDiaspora    torahReadingsEDiaspora
#define uTorahReadingsEIsrael      torahReadingsEIsrael
#define uTorahReadingsF            torahReadingsF
#define uTorahReadingsG            torahReadingsG
#define uTorahReadingsHDiaspora    torahReadingsHDiaspora
#define uTorahReadingsHIsrael      torahReadingsHIsrael
#define uTorahReadingsI            torahReadingsI
#define uTorahReadingsJ            torahReadingsJ
#define uTorahReadingsKDiaspora    torahReadingsKDiaspora
#define uTorahReadingsKIsrael      torahReadingsKIsrael
#define uTorahReadingsLDiaspora    torahReadingsLDiaspora
#define uTorahReadingsLIsrael      torahReadingsLIsrael
#define uTorahReadingsM            torahReadingsM
#define uTorahReadingsNDiaspora    torahReadingsNDiaspora
#define uTorahReadingsNIsrael      torahReadingsNIsrael

#define uID_1     id1
#define uID_2     id2
#define uID_3     id3

#endif

