#define ZMANIMDLG_INTERNAL
#include <gtk/gtk.h>
#include "config.h"
#include "dialogs.h"
#include "ini.h"
#include "zmanim.h"
#include "zmanimdlg.h"

int idZmanimdlgClickedButton;

void ZmanimdlgButton(GtkWidget *widget, gpointer data)
{
  idZmanimdlgClickedButton = (int) data;
}

ZMANIMDLG_EXTERN void ZmanimdlgDoDialog(void)
{
  GtkDialog *dialog;
  GtkLabel **labels, *label;
  GtkCombo **combos;
  GtkTable *table;
  GList *list;
  GtkButton *button;
  int i, j, iZmanim, count, maxWidth, isOk;
  char *currentGroup, *comboText;
  char text[256], key[256], groupName[256];
  GtkRequisition req;

  dialog = GTK_DIALOG(gtk_dialog_new());
  gtk_window_set_title(GTK_WINDOW(dialog),
                       "Configure Zmanim");

  labels = (GtkLabel **) malloc(100 * sizeof(GtkLabel *));
  combos = (GtkCombo **) malloc(100 * sizeof(GtkCombo *));

  i = 0;
  iZmanim = 0;
  for (;;)
  {
    if (ZmanimRecs[iZmanim].iType == ZMANIM_NULL)
      break;
    if (ZmanimRecs[iZmanim].iType == ZMANIM_GROUP)
    {
      i++;
      if (strcmp(ZmanimRecs[iZmanim].achName2, "") != 0)
        i++;
    }
    iZmanim++;
  }

  table = GTK_TABLE(gtk_table_new(i, 2, FALSE));

  i = 0;
  j = 0;
  iZmanim = 0;
  for (;;)
  {
    if (ZmanimRecs[iZmanim].iType == ZMANIM_NULL)
      break;
    if (ZmanimRecs[iZmanim].iType == ZMANIM_GROUP)
    {
      labels[i] = GTK_LABEL(gtk_label_new(ZmanimRecs[iZmanim].achName1));
      gtk_table_attach(GTK_TABLE(table),
                       GTK_WIDGET(labels[i]),
                       0, 1, j, j+1,
                       GTK_FILL, GTK_FILL,
                       0, 0);
      gtk_widget_show(GTK_WIDGET(labels[i]));
      if (strcmp(ZmanimRecs[iZmanim].achName2, "") != 0)
      {
        j++;
        label = GTK_LABEL(gtk_label_new(ZmanimRecs[iZmanim].achName2));
        gtk_table_attach(GTK_TABLE(table),
                         GTK_WIDGET(label),
                         0, 1, j, j+1,
                         GTK_FILL, GTK_FILL,
                         0, 0);
        gtk_widget_show(GTK_WIDGET(label));
      }

      combos[i] = GTK_COMBO(gtk_combo_new());

      list = g_list_alloc();
      currentGroup = (char *) ZmanimRecs[iZmanim].lpvData;
      while (strcmp(currentGroup, "") != 0)
      {
        strcpy(text, currentGroup + ZMANIMMAX);
        g_list_append(list, strdup(text));
        currentGroup += 3*ZMANIMMAX;
      }
      gtk_combo_set_popdown_strings(GTK_COMBO(combos[i]), list);

      gtk_combo_set_value_in_list(GTK_COMBO(combos[i]), TRUE, FALSE);

      strcpy(key, "Zmanim");
      strcat(key, ZmanimRecs[iZmanim].achInternalName);
      SettingsGet(key, groupName, "");
      currentGroup = (char *) ZmanimRecs[iZmanim].lpvData;
      strcpy(text, currentGroup + ZMANIMMAX);
      while (strcmp(currentGroup, "") != 0)
      {
        if (strcmp(currentGroup, groupName) == 0)
        {
          strcpy(text, currentGroup + ZMANIMMAX);
          break;
        }
        else
          currentGroup += 3*ZMANIMMAX;
      }
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combos[i])->entry), text);

      gtk_table_attach(GTK_TABLE(table),
                       GTK_WIDGET(combos[i]),
                       1, 2, j, j+1,
                       GTK_FILL, GTK_FILL,
                       0, 0);
      gtk_widget_show(GTK_WIDGET(combos[i]));
      i++;
      j++;
    }
    iZmanim++;
  }
  count = i;

  maxWidth = 0;
  for (i = 0; i < count; i++)
  {
    gtk_widget_size_request(GTK_WIDGET(labels[i]), &req);
    if (req.width > maxWidth)
      maxWidth = req.width;
  }

  for (i = 0; i < count; i++)
  {
    gtk_widget_size_request(GTK_WIDGET(combos[i]), &req);
    req.width = (INITIAL_WIDTH - maxWidth - 5);
    gtk_widget_set_usize(GTK_WIDGET(combos[i]), req.width, req.height);
  }

  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),
                    GTK_WIDGET(table));
  gtk_widget_show(GTK_WIDGET(table));

  button = GTK_BUTTON(gtk_button_new_with_label("OK"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(ZmanimdlgButton),
                     (gpointer) 1);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  button = GTK_BUTTON(gtk_button_new_with_label("Cancel"));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(ZmanimdlgButton),
                     (gpointer) 2);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
                     GTK_WIDGET(button), TRUE, TRUE, 0);
  gtk_widget_show(GTK_WIDGET(button));

  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
                     GTK_SIGNAL_FUNC(ZmanimdlgButton),
                     (gpointer) 2);

  idZmanimdlgClickedButton = (-1);

  gtk_widget_show(GTK_WIDGET(dialog));

  isOk = 0;
  while (!isOk)
  {
    while (idZmanimdlgClickedButton == (-1))
    {
/*    if (gtk_events_pending())*/
        gtk_main_iteration();
    }
    switch (idZmanimdlgClickedButton)
    {
      case 1:
        {
          isOk = 1;

          i = 0;
          iZmanim = 0;
          for (;;)
          {
            if (ZmanimRecs[iZmanim].iType == ZMANIM_NULL)
              break;
            if (ZmanimRecs[iZmanim].iType == ZMANIM_GROUP)
            {
              comboText = (char *) gtk_entry_get_text
                               (GTK_ENTRY(GTK_COMBO(combos[i])->entry));
              currentGroup = (char *) ZmanimRecs[iZmanim].lpvData;
              strcpy(text, "");
              while (strcmp(currentGroup, "") != 0)
              {
                if (strcmp(currentGroup + ZMANIMMAX, comboText) == 0)
                {
                  strcpy(text, currentGroup);
                  break;
                }
                else
                  currentGroup += 3*ZMANIMMAX;
              }
              if (strcmp(text, "") != 0)
              {
                strcpy(key, "Zmanim");
                strcat(key, ZmanimRecs[iZmanim].achInternalName);
                SettingsSet(key, text);
              }
              else
              {
                sprintf(text, "An entry under %s\n%s must be selected",
                        ZmanimRecs[iZmanim].achName1,
                        ZmanimRecs[iZmanim].achName2);
                DialogsDoMessage(text);

                idZmanimdlgClickedButton = (-1);
                isOk = 0;

                break;
              }
              i++;
            }
            iZmanim++;
          }
        }
        break;
      case 2:
        isOk = 1;
        break;
    }
  }

  if (GTK_IS_DIALOG(dialog)) gtk_widget_destroy(GTK_WIDGET(dialog));

  free(labels);
  free(combos);
}
